//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "MainUnit.h"
#include <stdlib.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
TCustomCard *TempCard;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
// used to seed the random function
	randomize();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{

// Create 52 card deck owned by panel named Deck.
// The Parent is set to Deck, this property is changed to either Hand or Discard
// to maneuver the cards
  for(int suit=0;suit<4;suit++)
  {
    for(int cvalue=0;cvalue<13;cvalue++)
    {
      TCustomCard* NewCard=new TCustomCard(Deck);
      NewCard->Parent=Deck;
      NewCard->Top=33;
      NewCard->Left=33;
      NewCard->CardSuit=suit;
      NewCard->CardValue=cvalue;
      NewCard->ShowFace=False;
    }
  }
}

//Enables the Draw button to draw from the deck
void __fastcall TForm1::UpdateLabels(void)
{
  if(Hand->ControlCount<5) BitBtn2->Enabled=True;
  else BitBtn2->Enabled=False;
}

//---------------------------------------------------------------------------
// Deals 5 cards to the Hand panel
void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
  int t=0,ctr=0;
  if(Hand->ControlCount>0) // Clear the hand
  while(ctr<Hand->ControlCount)
  {
      TempCard=(dynamic_cast<TCustomCard *>(Hand->Controls[Hand->ControlCount-1]));
      TempCard->Parent=Discard;
      TempCard->Top=33;
      TempCard->Left=33;
      TempCard->ShowFace=False;
  }
  //reshuffle if not enough cards
  if(Deck->ControlCount<10)
  {
    while(ctr<Discard->ControlCount)
    {
      TempCard=(dynamic_cast<TCustomCard *>(Discard->Controls[Discard->ControlCount-1]));
      TempCard->Parent=Deck;
      TempCard->Top=33;
      TempCard->Left=33;
      TempCard->ShowFace=False;
    }
  }
  for(int i=0;i<5;i++)
  {
    t=random(Deck->ControlCount);
    TempCard=(dynamic_cast<TCustomCard *>(Deck->Controls[t]));
    TempCard->Parent=Hand;
    TempCard->ShowFace=True;
    TempCard->Top=16;
    TempCard->Left=(i*80)+32;
  }
  UpdateLabels();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DiscardDragDrop(TObject *Sender, TObject *Source,
      int X, int Y)
{
  // Card dropped on the Discard panel
  TempCard=(dynamic_cast<TCustomCard *>(Source));
  TempCard->Parent=Discard;
  TempCard->Top=33;
  TempCard->Left=33;
  TempCard->ShowFace=False;
  UpdateLabels();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DiscardDragOver(TObject *Sender, TObject *Source,
      int X, int Y, TDragState State, bool &Accept)
{
	Accept = Source->ClassNameIs("TCustomCard");
}
//---------------------------------------------------------------------------
// Draws one card from the deck to the Hand
void __fastcall TForm1::BitBtn2Click(TObject *Sender)
{
  int t=0;
  t=random(Deck->ControlCount);
  TempCard=(dynamic_cast<TCustomCard *>(Deck->Controls[t]));
  TempCard->Parent=Hand;
  TempCard->ShowFace=True;
  TempCard->Top=16;

  for(int i=0;i<Hand->ControlCount;i++)
  {
  	TempCard=(dynamic_cast<TCustomCard *>(Hand->Controls[i]));
		TempCard->Left=(i*80)+32;
  }
  UpdateLabels();
}
//---------------------------------------------------------------------------

// Shuffles the deck.  Puts all the Cards back in the Deck panel.
void __fastcall TForm1::BitBtn3Click(TObject *Sender)
{

  int ctr=0;
  while(ctr<Hand->ControlCount)
  {
      TempCard=(dynamic_cast<TCustomCard *>(Hand->Controls[Hand->ControlCount-1]));
      TempCard->Parent=Deck;
      TempCard->Top=33;
      TempCard->Left=33;
      TempCard->ShowFace=False;
  }
  while(ctr<Discard->ControlCount)
  {
    TempCard=(dynamic_cast<TCustomCard *>(Discard->Controls[Discard->ControlCount-1]));
    TempCard->Parent=Deck;
    TempCard->Top=33;
    TempCard->Left=33;
    TempCard->ShowFace=False;
  }
  UpdateLabels();
}
//---------------------------------------------------------------------------

